import type { ECharts, EChartsOption } from 'echarts';
import type { EChartsData, EChartsInitOpts } from './eChartsTypes';
export declare abstract class EChartsBaseChart {
    protected chart: ECharts;
    protected option: EChartsOption;
    constructor(element: HTMLElement | null, option: EChartsOption, initOptions: EChartsInitOpts, data?: EChartsData, theme?: string);
    updateData(data: EChartsData): void;
    setOption(option: EChartsOption): void;
    protected abstract init(element: HTMLElement | null, initOptions: EChartsInitOpts, theme?: string): ECharts;
    private mergeData;
}
