import { DataToJSON } from '../utils/dataToJSON';
export class EChartsBaseChart {
    chart;
    option;
    constructor(element, option, initOptions, data, theme) {
        this.option = option;
        this.chart = this.init(element, initOptions, theme);
        this.chart.setOption(this.mergeData(option, data));
    }
    updateData(data) {
        this.chart.setOption(this.mergeData(this.option, data));
    }
    setOption(option) {
        this.chart.setOption(option);
    }
    mergeData(option, data) {
        if (!data)
            return option;
        const dataset = new DataToJSON(data).call();
        // @ts-expect-error
        return { ...option, dataset };
    }
}
