import { Table } from 'apache-arrow';
class ArrowTableToJSON {
    data;
    constructor(data) {
        this.data = data;
    }
    call() {
        const { schema } = this.data;
        const { fields } = schema;
        const dimensions = fields.map((field) => field.name);
        const source = dimensions.reduce((obj, column, idx) => {
            obj[column] = this.data.getChildAt(idx)?.toArray() || [];
            return obj;
        }, {});
        return { dimensions, source };
    }
}
export class DataToJSON {
    data;
    constructor(data) {
        this.data = data;
    }
    call() {
        if (!this.data)
            return { source: [] };
        if (Array.isArray(this.data)) {
            return this.data.length > 0 && this.data[0] instanceof Table
                ? this.data.map((table) => this.transform(table))
                : this.ArrayToJSON(this.data);
        }
        return this.transform(this.data);
    }
    transform(data) {
        return data instanceof Table
            ? new ArrowTableToJSON(data).call()
            : { source: data };
    }
    ArrayToJSON(data) {
        if (data.length > 0) {
            const dimensions = Object.keys(data[0]);
            return { dimensions, source: data };
        }
        return { source: data };
    }
}
